/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 8985_SUPSTPS.sql

Descrio:
Calcula os impostos dos itens de pedidos de coleta originados da web

Criao:
12/02/2008 Marcelo Alexsandro Souza Silva
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'IMPOSTO_ITEMPEDCOL'  and
            type = 'P'                  and
            u.uid = o.uid               and
            u.name = USER)
  DROP PROCEDURE IMPOSTO_ITEMPEDCOL
  GO

CREATE PROCEDURE IMPOSTO_ITEMPEDCOL @P_EMPRESA      VARCHAR(2),
                                    @P_INSCESTA     VARCHAR(16),
                                    @P_FILCENT      VARCHAR(4),
                                    @P_LANCCOLP     VARCHAR(10),
                                    @P_CDFORNECED   VARCHAR(21),
                                    @P_CDREGIAO     VARCHAR(3),
                                    @P_CDPRODUTO    VARCHAR(10),
                                    @P_CDMARCA      VARCHAR(5),
                                    @P_INIVALID     DATETIME,
                                    @P_VRITEMPEDCOL   DOUBLE PRECISION,
                                    @P_VRPERDESPEDCOL DOUBLE PRECISION
AS
   DECLARE @V_PAISORIG     VARCHAR(04);
   DECLARE @V_ESTAORIG     VARCHAR(02);
   DECLARE @V_MUNIORIG     VARCHAR(04);
   DECLARE @V_PAISDEST     VARCHAR(04);
   DECLARE @V_ESTADEST     VARCHAR(02);
   DECLARE @V_ALIQTEMP     VARCHAR(18);
   DECLARE @V_INCITEMP     VARCHAR(18);
   DECLARE @V_TIPOOPER     VARCHAR(02);
   DECLARE @V_CARACFIS     VARCHAR(01);
   DECLARE @V_LIQUIITEM    NUMERIC(15,6);
   DECLARE @V_PARDEDTMP    NUMERIC(15,6);
   DECLARE @V_PREDBCTMP    NUMERIC(15,6);
   DECLARE @V_ALIQUTMP     NUMERIC(15,6);
   DECLARE @V_IMPOSTOIT    NUMERIC(15,6);
   DECLARE @V_TAXABASECALC NUMERIC(15,6);
   DECLARE @V_TAXAALIQUOTA NUMERIC(15,6);
   DECLARE @V_BASECALCIT   NUMERIC(15,6);
   DECLARE @V_CONTABCALC   NUMERIC(15,6);
   DECLARE @V_PERDBCALC    NUMERIC(15,6);
   DECLARE @V_ADIMPAF      NUMERIC(15,6);
   DECLARE @V_TOTAIMPBCALC NUMERIC(15,6);
   DECLARE @V_QTACMPITMCOL NUMERIC(15,6);
   DECLARE @V_CDARVPROD    VARCHAR(20);
   DECLARE @V_IDINTEREST   VARCHAR(01);

   DECLARE @V_STRING_AUX   VARCHAR(2000);
   /*VARIVEIS DO CURSOR C_ITEMCOLP*/
   DECLARE @V_ITEMCOLP_VRPRECUNIITM NUMERIC(15,5);
   DECLARE @V_ITEMCOLP_VRPERDESITM  NUMERIC(6,2);
   DECLARE @V_ITEMCOLP_QTACMPITMCOL NUMERIC(10,3);

   /*VARIVEIS DO CURSOR C_INCIDENCIA*/
   DECLARE @V_INCIDEN_CDIMPOTEMP   VARCHAR(2);
   DECLARE @V_INCIDEN_CDFISCTEMP   VARCHAR(1);
   DECLARE @V_INCIDEN_IDTRATIMPO   VARCHAR(1);
   DECLARE @V_INCIDEN_IDIMPORECUP  VARCHAR(1);
   DECLARE @V_INCIDEN_IDIMPDIGCOL  VARCHAR(1);
   DECLARE @V_INCIDEN_VRALIQIMPCOL NUMERIC(16, 2);

   /* VARIVEIS DO CURSOR C_PRODUTO*/
   DECLARE @V_PRODUTO_CDFORNECED   VARCHAR(21);
   DECLARE @V_PRODUTO_CDREGIAO     VARCHAR(3);
   DECLARE @V_PRODUTO_CDPRODUTO    VARCHAR(10);
   DECLARE @V_PRODUTO_CDMARCA      VARCHAR(5);
   DECLARE @V_PRODUTO_CDIMPOSTO    VARCHAR(2);
   DECLARE @V_PRODUTO_VRALIQIMPCOL NUMERIC(16,2);
   DECLARE @V_PRODUTO_VRPERRBCALCO NUMERIC(10,2);
   DECLARE @V_PRODUTO_VRIMPCOLETA  NUMERIC(16,2);
   DECLARE @V_PRODUTO_VRPARCDEDCOL NUMERIC(16,2);
   DECLARE @V_PRODUTO_CDFISCITMCOL VARCHAR(1);
   DECLARE @V_PRODUTO_IDTRATIMPO   VARCHAR(1);
   DECLARE @V_PRODUTO_IDIMPORECUP  VARCHAR(1);
   DECLARE @V_INSCESTA             VARCHAR(16);
   DECLARE @V_CDGRUPOFISC          VARCHAR(3);

   DECLARE @V_CDIMPOBCALTPOP       VARCHAR(2);

BEGIN
   EXEC CONSULTA_GRUPOFISCAL 'F', @P_CDFORNECED, '', 'E', '01', @P_CDGRUPOFISC = @V_CDGRUPOFISC OUTPUT;

--Variveis com a chave para as tabelas temporrias

   SET @V_ALIQTEMP = 'COLP'+@P_FILCENT+@P_LANCCOLP;
   SET @V_INCITEMP = 'COLP'+@P_FILCENT+@P_LANCCOLP;
---------------------------------------------------------------------------------------------------------

  SELECT @V_INSCESTA = MAX(CDINSCESTA)
  FROM FILIAL
  WHERE
   CDFILIAL  = @P_FILCENT AND
   CDEMPRESA = @P_EMPRESA;

  SELECT @V_CDARVPROD = MAX(CDARVPROD)
  FROM PRODUTO
  WHERE CDPRODUTO = @P_CDPRODUTO;

--Variveis para consulta de Alquota, Incidncia
   SELECT @V_PAISDEST = MAX(CDPAIS),
          @V_ESTADEST = MAX(SGESTADO)
   FROM REGIAO
   WHERE (CDREGIAO = @P_CDREGIAO);

   SELECT @V_PAISORIG = MAX(CDPAIS),
          @V_ESTAORIG = MAX(SGESTADO),
          @V_MUNIORIG = MAX(CDMUNICIPIO)
   FROM ENDEFORN
   WHERE (CDFORNECED   = @P_CDFORNECED) AND
         (IDTPENDEFORN = 'P');

   SELECT @V_TIPOOPER = MAX(CDTIPOOPER)
   FROM PARCMPSUP
   WHERE CDFILIAL = @P_FILCENT;

   IF (@V_TIPOOPER IS NULL) BEGIN
      SET @V_TIPOOPER = '01';
   END;

   SELECT @V_CARACFIS = MAX(IDCARACFIS)
   FROM PARAMFILIAL
   WHERE CDFILIAL = @P_FILCENT;
---------------------------------------------------------------------------------------------------------

-- Atualizao da tabela de ItemCol
   DECLARE C_ITEMCOLP CURSOR FOR
      (SELECT @P_VRITEMPEDCOL   VRPRECUNIITM,
              @P_VRPERDESPEDCOL VRPERDESITM)

   OPEN C_ITEMCOLP;
   FETCH NEXT FROM C_ITEMCOLP INTO @V_ITEMCOLP_VRPRECUNIITM, @V_ITEMCOLP_VRPERDESITM;
	WHILE (@@FETCH_STATUS = 0)
   BEGIN
      IF (@V_ITEMCOLP_VRPERDESITM IS NULL) BEGIN
         SET @V_LIQUIITEM = @V_ITEMCOLP_VRPRECUNIITM;
      END
      ELSE
      BEGIN
         SET @V_LIQUIITEM = (@V_ITEMCOLP_VRPRECUNIITM) * ((100 - @V_ITEMCOLP_VRPERDESITM)/100);
      END;

      SET @V_STRING_AUX = 'COLP'+@P_FILCENT;

      SET @V_IDINTEREST = 'N';
      IF (@V_PAISDEST = @V_PAISORIG) AND (@V_ESTADEST <> @V_ESTAORIG) BEGIN
         SET @V_IDINTEREST = 'S';
      END;

      EXEC CONSULTA_INCIDENCIA 'E', @P_EMPRESA, @V_CDARVPROD, @V_INSCESTA, @V_TIPOOPER, @V_STRING_AUX, @P_LANCCOLP, @V_CDGRUPOFISC, NULL, @V_IDINTEREST;

---------------------------------------------------------------------------------------------------------
--Atualizao da tabela de impostos por item.

      DECLARE C_INCIDENCIA CURSOR FOR
         SELECT DISTINCT
            CDIMPOTEMP AS CDIMPOTEMP,
            CDFISCTEMP,
            IP.IDTRATIMPO,
            IP.IDIMPORECUP,
            ISNULL(IMPPEDCOLETA.IDIMPDIGPEDCOL, 'N') AS IDIMPDIGCOL,
            IMPPEDCOLETA.VRALIQIMPPEDCOL
         FROM INCITEMP IT,
              IMPOSTO IP LEFT JOIN IMPPEDCOLETA ON
                                   (IMPPEDCOLETA.CDIMPOSTO   = IP.CDIMPOSTO)  AND
                                   (IMPPEDCOLETA.CDFILIAL    = @P_FILCENT)    AND
                                   (IMPPEDCOLETA.NRPEDCOLETA = @P_LANCCOLP)   AND
                                   (IMPPEDCOLETA.CDFORNECED  = @P_CDFORNECED) AND
                                   (IMPPEDCOLETA.CDREGIAO    = @P_CDREGIAO)   AND
                                   (IMPPEDCOLETA.CDPRODUTO   = @P_CDPRODUTO)  AND
                                   (IMPPEDCOLETA.CDMARCA     = @P_CDMARCA)
         WHERE (IT.NRINCITEMP = @V_INCITEMP)   AND
               (IP.CDIMPOSTO  = IT.CDIMPOTEMP) AND
               (IP.IDPRODNOTA = 'P');

      OPEN C_INCIDENCIA;
      FETCH NEXT FROM C_INCIDENCIA INTO @V_INCIDEN_CDIMPOTEMP,  @V_INCIDEN_CDFISCTEMP,
                                        @V_INCIDEN_IDTRATIMPO,  @V_INCIDEN_IDIMPORECUP,
                                        @V_INCIDEN_IDIMPDIGCOL, @V_INCIDEN_VRALIQIMPCOL;
      WHILE (@@FETCH_STATUS = 0)
      BEGIN

         SET  @V_STRING_AUX = 'COLP'+@P_FILCENT;
         EXEC CONSULTA_ALIQUOTA @V_INCIDEN_CDIMPOTEMP, 'E', @P_EMPRESA, @V_CDARVPROD, @V_INSCESTA, @V_PAISORIG,
                                @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIORIG, @V_LIQUIITEM, @P_INIVALID,
                                @V_STRING_AUX, @P_LANCCOLP, @V_CDGRUPOFISC, @V_TIPOOPER;

         SET @V_PARDEDTMP = 0;
         SET @V_PREDBCTMP = 0;
         SET @V_ALIQUTMP  = 0;
         SET @V_IMPOSTOIT = 0;

         SELECT @V_PARDEDTMP = MAX(VRPARDEDTMP),
                @V_PREDBCTMP = MAX(VRPREDBCTMP),
                @V_ALIQUTMP  = MAX(VRALIQUTMP)
         FROM ALIQTEMP
         WHERE (NRALIQTEMP = @V_ALIQTEMP);

         IF (@V_ALIQUTMP IS NULL) BEGIN
             -- FOI RETIRADO POIS DEVE SER CALCULADO MAS NAO DEVER SER TOTALIZADO FUTURAMENTE
             -- OR (@V_INCIDEN_IDIMPORECUP = 'S' AND @V_INCIDEN_CDFISCTEMP <> '1') BEGIN
            SET @V_ALIQUTMP = 0;
         END
         ELSE IF @V_INCIDEN_IDIMPDIGCOL = 'S' BEGIN
            SET @V_ALIQUTMP = @V_INCIDEN_VRALIQIMPCOL;
         END;

         IF (@V_PREDBCTMP IS NULL) BEGIN
            SET @V_PREDBCTMP = 0;
         END;

         IF (@V_PARDEDTMP IS NULL) BEGIN
             SET @V_PARDEDTMP = 0;
         END;

         SET @V_TAXABASECALC = (100 - @V_PREDBCTMP)/100;
         SET @V_TAXAALIQUOTA = (@V_ALIQUTMP/100);
         SET @V_BASECALCIT   = @V_LIQUIITEM * @V_TAXABASECALC;
         SET @V_IMPOSTOIT    = ((@V_LIQUIITEM * @V_TAXABASECALC) * @V_TAXAALIQUOTA) - @V_PARDEDTMP;

         SET @V_CONTABCALC = @V_LIQUIITEM - (@V_LIQUIITEM * @V_TAXABASECALC);
         SET @V_PERDBCALC  = 100 - @V_PREDBCTMP;

         IF (@V_IMPOSTOIT < 0) BEGIN
            SET @V_IMPOSTOIT = 0;
         END;

         SET @V_ADIMPAF = 0;
         IF (@V_INCIDEN_IDTRATIMPO = 'A') BEGIN
            SET @V_ADIMPAF = @V_IMPOSTOIT;
         END
         ELSE IF (@V_INCIDEN_IDTRATIMPO = 'D') BEGIN
            SET @V_ADIMPAF = - @V_IMPOSTOIT;
         END;

         DELETE IMPPEDCOLETA
         WHERE (CDFILIAL    = @P_FILCENT)    AND
               (NRPEDCOLETA = @P_LANCCOLP)   AND
               (CDFORNECED  = @P_CDFORNECED) AND
               (CDREGIAO    = @P_CDREGIAO)   AND
               (CDPRODUTO   = @P_CDPRODUTO)  AND
               (CDMARCA     = @P_CDMARCA)    AND
               (CDIMPOSTO   = @V_INCIDEN_CDIMPOTEMP);

         INSERT INTO IMPPEDCOLETA(CDFILIAL,NRPEDCOLETA,CDFORNECED,CDREGIAO,
                                  CDPRODUTO,CDMARCA,CDIMPOSTO,VRALIQIMPPEDCOL,
                                  VRPERRBCALPEDCO,VRIMPPEDCOL,VRBASECALPEDCOL,
                                  VRPARCDEDPEDCOL,CDFISCITMPEDCOL,VRADIMPPEDCOL,
                                  IDIMPDIGPEDCOL)
         VALUES(@P_FILCENT, @P_LANCCOLP, @P_CDFORNECED, @P_CDREGIAO,
                @P_CDPRODUTO, @P_CDMARCA, @V_INCIDEN_CDIMPOTEMP,@V_ALIQUTMP,
                @V_PREDBCTMP, @V_IMPOSTOIT, @V_BASECALCIT, @V_PARDEDTMP,
                @V_INCIDEN_CDFISCTEMP, @V_ADIMPAF, @V_INCIDEN_IDIMPDIGCOL);
         DELETE ALIQTEMP
         WHERE NRALIQTEMP = @V_ALIQTEMP;

         FETCH NEXT FROM C_INCIDENCIA INTO @V_INCIDEN_CDIMPOTEMP,  @V_INCIDEN_CDFISCTEMP,
                                           @V_INCIDEN_IDTRATIMPO,  @V_INCIDEN_IDIMPORECUP,
                                           @V_INCIDEN_IDIMPDIGCOL, @V_INCIDEN_VRALIQIMPCOL;
      END;
      CLOSE C_INCIDENCIA;
      DEALLOCATE C_INCIDENCIA;

      DELETE INCITEMP
      WHERE NRINCITEMP = @V_INCITEMP;

      FETCH NEXT FROM C_ITEMCOLP INTO @V_ITEMCOLP_VRPRECUNIITM, @V_ITEMCOLP_VRPERDESITM;
   END;
   CLOSE C_ITEMCOLP;
   DEALLOCATE C_ITEMCOLP;

---------------------------------------------------------------------------------------------------------
--Clculo do Valor dos Impostos que contm outros impostos na sua Base de Clculo

   DECLARE C_PRODUTO CURSOR FOR
      (SELECT @P_CDFORNECED AS CDFORNECED, @P_CDREGIAO AS CDREGIAO, @P_CDPRODUTO AS CDPRODUTO,
              @P_CDMARCA AS CDMARCA, II.CDIMPOSTO, II.VRALIQIMPPEDCOL AS VRALIQIMPCOL,
              II.VRPERRBCALPEDCO AS VRPERRBCALCO,
              II.VRIMPPEDCOL AS VRIMPCOLETA, II.VRPARCDEDPEDCOL AS VRPARCDEDCOL,
              II.CDFISCITMPEDCOL AS CDFISCITMCOL, IM.IDTRATIMPO, IM.IDIMPORECUP
      FROM IMPPEDCOLETA II, IMPOSTO IM
      WHERE (II.CDFILIAL     = @P_FILCENT)   AND
            (II.NRPEDCOLETA  = @P_LANCCOLP)  AND
            (II.CDFORNECED   = @P_CDFORNECED)AND
            (II.CDREGIAO     = @P_CDREGIAO)  AND
            (II.CDPRODUTO    = @P_CDPRODUTO) AND
            (II.CDMARCA      = @P_CDMARCA)   AND
            (IM.CDIMPOSTO    = II.CDIMPOSTO) AND
            (II.IDIMPDIGPEDCOL = 'N'))

   OPEN C_PRODUTO;
   FETCH NEXT FROM C_PRODUTO INTO @V_PRODUTO_CDFORNECED  , @V_PRODUTO_CDREGIAO,
                                  @V_PRODUTO_CDPRODUTO   , @V_PRODUTO_CDMARCA,
                                  @V_PRODUTO_CDIMPOSTO   , @V_PRODUTO_VRALIQIMPCOL,
                                  @V_PRODUTO_VRPERRBCALCO, @V_PRODUTO_VRIMPCOLETA,
                                  @V_PRODUTO_VRPARCDEDCOL, @V_PRODUTO_CDFISCITMCOL,
                                  @V_PRODUTO_IDTRATIMPO  , @V_PRODUTO_IDIMPORECUP;
   WHILE (@@FETCH_STATUS = 0)
   BEGIN
      SET @V_TOTAIMPBCALC = NULL;
      SET @V_CDIMPOBCALTPOP = NULL;

      SELECT @V_CDIMPOBCALTPOP = MAX(BC.CDIMPOBCALC), @V_TOTAIMPBCALC = SUM(VRIMPPEDCOL)
      FROM IMPPEDCOLETA II, BASECALCTPOPER BC
      WHERE (BC.IDENTRSAIDOP   = 'E')
        AND (BC.CDTIPOOPER     = @V_TIPOOPER)
        AND (BC.CDIMPOSTO      = @V_PRODUTO_CDIMPOSTO)
        AND (II.CDFILIAL       = @P_FILCENT)
        AND (II.NRPEDCOLETA    = @P_LANCCOLP)
        AND (II.CDFORNECED     = @V_PRODUTO_CDFORNECED)
        AND (II.CDREGIAO       = @V_PRODUTO_CDREGIAO)
        AND (II.CDPRODUTO      = @V_PRODUTO_CDPRODUTO)
        AND (II.CDMARCA        = @V_PRODUTO_CDMARCA)
        AND (II.CDIMPOSTO      = BC.CDIMPOBCALC)
        AND (II.IDIMPDIGPEDCOL = 'N')
        AND ((@V_PRODUTO_CDFISCITMCOL = BC.CDFISCIMPOTPOP) OR (BC.CDFISCIMPOTPOP IS NULL));

      IF @V_CDIMPOBCALTPOP IS NULL BEGIN
         SELECT @V_TOTAIMPBCALC = SUM(VRIMPPEDCOL)
         FROM IMPPEDCOLETA II, BASECALC BC
         WHERE (BC.CDIMPOSTO      = @V_PRODUTO_CDIMPOSTO)   AND
               (II.CDFILIAL       = @P_FILCENT)             AND
               (II.NRPEDCOLETA    = @P_LANCCOLP)         AND
               (II.CDFORNECED     = @V_PRODUTO_CDFORNECED)  AND
               (II.CDREGIAO       = @V_PRODUTO_CDREGIAO)    AND
               (II.CDPRODUTO      = @V_PRODUTO_CDPRODUTO)   AND
               (II.CDMARCA        = @V_PRODUTO_CDMARCA)     AND
               (II.CDIMPOSTO      = BC.CDIMPOBCALC)         AND
               (II.IDIMPDIGPEDCOL = 'N')                    AND
               ((@V_PRODUTO_CDFISCITMCOL = BC.CDFISCIMPO) OR (BC.CDFISCIMPO IS NULL)) AND
               (BC.IDTIPOBCALC   = 'I');
      END;

      IF NOT (@V_TOTAIMPBCALC IS NULL) BEGIN
         SET @V_TAXABASECALC = (100 - @V_PRODUTO_VRPERRBCALCO)/100;
         SET @V_TAXAALIQUOTA = (@V_PRODUTO_VRALIQIMPCOL/100);

         UPDATE IMPPEDCOLETA
         SET VRBASECALPEDCOL = VRBASECALPEDCOL + (@V_TOTAIMPBCALC * @V_TAXABASECALC),
             VRIMPPEDCOL  = VRIMPPEDCOL  + ((@V_TOTAIMPBCALC * @V_TAXABASECALC) * @V_TAXAALIQUOTA)
         WHERE (CDFILIAL    = @P_FILCENT)             AND
               (NRPEDCOLETA = @P_LANCCOLP)            AND
               (CDFORNECED  = @V_PRODUTO_CDFORNECED)  AND
               (CDREGIAO    = @V_PRODUTO_CDREGIAO)    AND
               (CDPRODUTO   = @V_PRODUTO_CDPRODUTO)   AND
               (CDMARCA     = @V_PRODUTO_CDMARCA)     AND
               (CDIMPOSTO   = @V_PRODUTO_CDIMPOSTO);
      END;
      FETCH NEXT FROM C_PRODUTO INTO @V_PRODUTO_CDFORNECED  , @V_PRODUTO_CDREGIAO,
                                     @V_PRODUTO_CDPRODUTO   , @V_PRODUTO_CDMARCA,
                                     @V_PRODUTO_CDIMPOSTO   , @V_PRODUTO_VRALIQIMPCOL,
                                     @V_PRODUTO_VRPERRBCALCO, @V_PRODUTO_VRIMPCOLETA,
                                     @V_PRODUTO_VRPARCDEDCOL, @V_PRODUTO_CDFISCITMCOL,
                                     @V_PRODUTO_IDTRATIMPO  , @V_PRODUTO_IDIMPORECUP;

   END;
   CLOSE C_PRODUTO;
   DEALLOCATE C_PRODUTO;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'IMPOSTO_ITEMPEDCOL','5.05.005';
GO

